package vishnu.cluster;

import java.util.*;

public class Cluster
{
    public int id;
    public Cluster  parent = null;
    public Cluster  child_1 = null;
    public Cluster  child_2 = null;
    
    public double children_sim;
    
    // size of cluster
    public int items;
    
    public int split;
    
    // [] -> centroid for each vector element ?
    public float[] centroid=null;
    
    public Vector iter_items = null;
    public int iter_items_num = 0;
    
    public int x = 0;
    public int y = 0;
    
    public float[] getCentroid(){return centroid;}
    
    public Cluster(int id, Cluster parent, Cluster c1, Cluster c2, double children_sim, int items)
    {
	this.id               = id;
	this.children_sim     = children_sim;
	this.items            = items;
	split                 = 0;
	this.parent           = parent;
        iter_items            = new Vector(0);
        
        // probably to get a balanced tree
	if (c1 != null && c2 != null){
	    if (c2.items > c1.items){
		child_1 = c1;
		child_2 = c2;
	    }else{
	        child_1 = c2;
		child_2 = c1;
	    }
	}else{ // if either or both are null
	    child_1 = c1;
	    child_2 = c2;
	}
    }
    
    // a nice recursive function to determine the depth of the hierarchy
    public int depth()
    {
	if (id != -1)
	    return 0;
	else
	    return Math.max(1 + child_1.depth(), 1 + child_2.depth());
    }
    
    
    void addChildrenToOutputVector(int []coding, Vector output)
    {
	if (id != -1){
    	    Integer ii = new Integer(coding[id]);
            output.addElement(ii);
	}else{
      	    child_1.addChildrenToOutputVector(coding,output);
      	    child_2.addChildrenToOutputVector(coding,output);
	}
    }
}


